<?

include "class.sosumi.php";

// Parameter fuer Sonnenauf- und untergangsbestimmung
$SONNE_LONG =  "8.1234";      // Longitude (geografische Lnge)
$SONNE_LATI = "50.1234";   // Latitude (geografische Breite)
$SONNE_ZEITZONE = "Europe/Berlin"; // Berlin

// Parameter fr iphone Notifikation und -Suche
$IPHONE_USER = "testuser@apple.com";
$IPHONE_PASS = "passwort";
$IPHONE_ORTUNG = 34238 /*[Reports\iPhone Standort\Letzte Suche]*/ ; /* String, Profil Uhrzeit " Uhr" setzen */
$IPHONES = array( "QVBdddddddddfjsdgfjskdgfkdfksdfkdisfiduyfidsyfisdfyidsfydis~"
						=>	array(
                    "name" => 42105, /* Dummy Module */
					"dist" => 57507, /* Float, Profil Kilometer " km" setzen */
                  	"lati" => 27663, /* Float, Geog. Breite, Profil Grad setzen */
                  	"long" => 21805, /* Float, Geog. Lnge, Profil Grad setzen */
                  	"zeit" => 20143, /* String, Profil Uhrzeit " Uhr" setzen */
					"map"  => 26054, /* String, Profil "~HTMLBox" */
					"rad"  => 51612, /* Float, Profil " m" setzen */
					),
						"QVBaaaaaadskfhkjdshfkdshfkjdshfiuweyruiewyiuwehiwehfiwiwuee~"
						=> array(
					 "name" => 26399,
                     "dist" => 37831,
                     "lati" => 58309,
                     "long" => 25349,
                     "zeit" => 16358,
                     "map"  => 48166,
					 "rad"  => 58621,
						)
						);

// Berechnet Abstand auf Kugel zwischen den beiden Punkten
function distance($Alpha1, $Beta1, $Alpha2, $Beta2)
{
	// Longitude alpha 0..360 Grad, Latitude beta -90..90 Grad
	if (($Alpha1 <  0) || ($Alpha1 > 360 )) return false;
	if (($Beta1 < -90) || ($Beta1  >  90 )) return false;
	if (($Alpha2 <  0) || ($Alpha2 > 360 )) return false;
	if (($Beta2 < -90) || ($Beta2  >  90 )) return false;

	// Umrechnungsfaktor von Grad in Radian
	$DEG_RAD = 3.1415926535 / 180;
	// 6371 km Erdradius
	$EARTH_RADIUS = 6371;

	// Alle Werte in Radian umrechnen, weil php in Radian rechnet
	$Alpha_1 = $Alpha1 * $DEG_RAD;
	$Beta_1  = $Beta1  * $DEG_RAD;
	$Alpha_2 = $Alpha2 * $DEG_RAD;
	$Beta_2  = $Beta2  * $DEG_RAD;

	// Abstand bestimmen
	// Siehe: Herleitung einer Formel fr den Abstand zweier Punkte
	// auf einer Kugel bei gegebenen Drehwinkeln und gegebenem Radius,
	// dj3hut1, 4. Juli 2007
	$Arg = cos($Beta_1)* cos($Beta_2)* cos($Alpha_1 - $Alpha_2) + sin($Beta_1)* sin($Beta_2);
	$Abstand = $EARTH_RADIUS * acos($Arg);

	// Auf 1 m runden
	return (round($Abstand, 1));
}

// Merken, wann gestartet
SetValueString($IPHONE_ORTUNG, date("d.m.Y H:i:s", time()));

// Ortung aller registrierten Devices starten
$ssm = new Sosumi($IPHONE_USER, $IPHONE_PASS);

foreach($IPHONES as $index => $ids) {
	// Merken, wohin die Ergebnisse gespeichert werden sollen
	$IDname = $ids["name"];
	$IDdist = $ids["dist"];
	$IDlati = $ids["lati"];
	$IDlong = $ids["long"];
	$IDzeit = $ids["zeit"];
	$IDmap  = $ids["map"];
	$IDradius = $ids["rad"];
	// Namen des Gerts merken fr Webanzeige
	$devicename = IPS_GetName($IDname);

	// Max. 15 Sekunden warten, bis neue Ortung eintrifft
	// Suche nach Apple ID z.B. "QVBdddddddddfjsdgfjskdgfkdfksdfkdisfiduyfidsyfisdfyidsfydis~"
	$loc = $ssm->locate($index, 15);

	// Falls gefunden
	if ($loc !== false) {
		// Abstand bestimmen
		$dist = distance($SONNE_LONG, $SONNE_LATI, $loc['longitude'], $loc['latitude']);
		SetValue($IDdist, $dist);
		// Ortungsergebnisse merken
		$lat = $loc['latitude'];
		$lon = $loc['longitude'];
		$acc = round($loc['accuracy']);
		$tim = date("d.m.Y H:i:s", $loc['timestamp']);
		SetValue($IDlati, $lat);
		SetValue($IDlong, $lon);
		SetValue($IDradius, $acc);
		SetValue($IDzeit, $tim);
		IPS_SetName($IDzeit, "Erreicht um");

		// Karte anzeigen
		$maps = 'user/map.php';
		$para = "lat=$lat&lng=$lon&devicename=$devicename&altitude=$acc&date=$tim";
		$rahmen = 'border="0" frameborder="0"';
		$rahmen .= ' style="top:0pt; bottom:0pt; left:0pt; right:0pt; width:100%; height:440px;"';
		SetValueString($IDmap, "<iframe src=\"$maps?$para\" $rahmen></iframe>");
		$success = true;
		}
	else {
		IPS_SetName($IDzeit, "Nicht erreicht um");
		SetValue($IDzeit,  date("d.m.Y H:i:s", time()));
		$success = false;
		}

	// Variablen entsprechend anzeigen
	IPS_SetHidden($IDdist,   !$success);
	IPS_SetHidden($IDlati,   !$success);
	IPS_SetHidden($IDlong,   !$success);
	IPS_SetHidden($IDradius, !$success);

	}
?>